VERSION 5.00
Begin VB.Form AboutBox 
   AutoRedraw      =   -1  'True
   Caption         =   "About My Program"
   ClientHeight    =   5115
   ClientLeft      =   1245
   ClientTop       =   750
   ClientWidth     =   8790
   LinkTopic       =   "Form1"
   ScaleHeight     =   5115
   ScaleWidth      =   8790
   Begin VB.TextBox txtSystemInfo 
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      Height          =   4350
      Left            =   600
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   240
      Width           =   7200
   End
   Begin VB.Frame Frame1 
      Caption         =   "System Information"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4995
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   8685
   End
End
Attribute VB_Name = "AboutBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    Dim oSysInfo As New WinWorX.SystemInfo
    Dim oRegion  As New WinWorX.LocaleSettings

    Dim sSysInfo As String
    Dim i As Integer, sOS As String

    Dim et_DriveType As DRIVE_TYPE
    Dim et_OSVersion As OS_VERSION
    Dim sDriveType As String
    Dim dblValue As Double
    Dim sValue As String

    Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2, 6500, 9000

    With oSysInfo
        et_OSVersion = .OSVersion
        Select Case et_OSVersion
            Case OS_WINDOWS_3X:     sOS = "Windows 3.x with Win32s"
            Case OS_WINDOWS_95:     sOS = "Windows 95"
            Case OS_WINDOWS_98:     sOS = "Windows 98"
            Case OS_WINDOWS_NT3X:   sOS = "Windows NT 3.x"
            Case OS_WINDOWS_NT40:   sOS = "Windows 4.0"
            Case OS_WINDOWS_2000:   sOS = "Windows 2000"
            Case Else:              sOS = "(Unknown)"
        End Select

        sSysInfo = sSysInfo & "Operating System: " & sOS & vbCrLf & vbCrLf
        sSysInfo = sSysInfo & "Computer Name: " & .ComputerName & vbCrLf
        sSysInfo = sSysInfo & "Current User: " & .CurrentUser & vbCrLf & vbCrLf
        sSysInfo = sSysInfo & "Total Memory Resources: " & .TotalMemory & " MB" & vbCrLf
        sSysInfo = sSysInfo & "Available Memory Resources: " & .AvailableMemory & " MB" & vbCrLf
        sSysInfo = sSysInfo & "Percent Free: " & .PercentMemoryFree & "%" & vbCrLf & vbCrLf
        sSysInfo = sSysInfo & "Total Physical Memory: " & .TotalPhysicalMemory & " MB" & vbCrLf
        sSysInfo = sSysInfo & "Available Physical Memory: " & .AvailablePhysicalMemory & " MB" & vbCrLf & vbCrLf
        sSysInfo = sSysInfo & "Drives: " & vbCrLf & vbCrLf

        For i = 65 To 90
            et_DriveType = .DriveType(Chr(i))
            If et_DriveType <> DRIVE_DOESNT_EXIST Then
                
                Select Case et_DriveType
                    Case DRIVE_REMOVABLE:   sDriveType = "Removable Drive"
                    Case DRIVE_FIXED:       sDriveType = "Local Hard Drive"
                    Case DRIVE_REMOTE:      sDriveType = "Network"
                    Case DRIVE_CDROM:       sDriveType = "CD-ROM"
                    Case DRIVE_RAMDISK:     sDriveType = "RAM Disk"
                End Select

                sSysInfo = sSysInfo & Chr(i) & ":\  " & Trim(.VolumeName(Chr(i))) & " (" & sDriveType & ")  "
                dblValue = .TotalMegaBytesOnDisk(Chr(i))
                If .SystemErrorCode = 0 Then
                    sSysInfo = sSysInfo & "Total Space: " & dblValue & "MB  "
                    dblValue = .FreeMegaBytesOnDisk(Chr(i))
                    sSysInfo = sSysInfo & "Free Space: " & dblValue & "MB"
                End If
                sSysInfo = sSysInfo & vbCrLf
            End If 'drive doesn't exist
        Next

        sSysInfo = sSysInfo & vbCrLf
        sValue = .ScreenResolution
        If .SystemErrorCode = 0 Then sSysInfo = sSysInfo & "Screen Resolution: " & sValue & vbCrLf
        dblValue = .MaxScreenColors
        If .SystemErrorCode = 0 Then sSysInfo = sSysInfo & "Maximum Screen Colors: " & Format(dblValue, "#,###,###,###,###")
    End With
    With oRegion
        sSysInfo = sSysInfo & vbCrLf & vbCrLf
        sSysInfo = sSysInfo & "Regional Locale" & vbCrLf
        sSysInfo = sSysInfo & "---------------" & vbCrLf
        sSysInfo = sSysInfo & vbCrLf
        sSysInfo = sSysInfo & "Country: " & .Country & vbCrLf
        sSysInfo = sSysInfo & "Currency: " & .CurrencySpecifier & vbCrLf
        sSysInfo = sSysInfo & "Date Time Format: " & .DateFormat & .TimeFormat & vbCrLf
        sSysInfo = sSysInfo & "Language: " & .LanguageName & vbCrLf
        sSysInfo = sSysInfo & "Native Country: " & .NativeCountryName & vbCrLf
        sSysInfo = sSysInfo & "System Language: " & .SysLanguageID & " - " & .SysLanguageName & vbCrLf
    End With
    txtSystemInfo.Text = sSysInfo
End Sub

Private Sub Form_Resize()
    With Frame1
        .Left = 0
        .Top = 0
        .Width = Me.ScaleWidth
        .Height = Me.ScaleHeight
    End With
    With txtSystemInfo
        .Top = Frame1.Top + 200
        .Left = Frame1.Left + 100
        .Width = Frame1.Width - 200
        .Height = Frame1.Height - 300
    End With
End Sub
